/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlySignerAccount, TransactionSigner, WritableAccount } from '@solana/web3.js';
import { PHOENIX_V1_PROGRAM_ADDRESS } from '../programs';
export type EvictSeatInstruction<TProgram extends string = typeof PHOENIX_V1_PROGRAM_ADDRESS, TAccountPhoenixProgram extends string | IAccountMeta<string> = string, TAccountLogAuthority extends string | IAccountMeta<string> = string, TAccountMarket extends string | IAccountMeta<string> = string, TAccountMarketAuthority extends string | IAccountMeta<string> = string, TAccountTrader extends string | IAccountMeta<string> = string, TAccountSeat extends string | IAccountMeta<string> = string, TAccountBaseAccount extends string | IAccountMeta<string> = string, TAccountQuoteAccount extends string | IAccountMeta<string> = string, TAccountBaseVault extends string | IAccountMeta<string> = string, TAccountQuoteVault extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPhoenixProgram extends string ? ReadonlyAccount<TAccountPhoenixProgram> : TAccountPhoenixProgram,
    TAccountLogAuthority extends string ? ReadonlyAccount<TAccountLogAuthority> : TAccountLogAuthority,
    TAccountMarket extends string ? WritableAccount<TAccountMarket> : TAccountMarket,
    TAccountMarketAuthority extends string ? ReadonlyAccount<TAccountMarketAuthority> : TAccountMarketAuthority,
    TAccountTrader extends string ? ReadonlyAccount<TAccountTrader> : TAccountTrader,
    TAccountSeat extends string ? ReadonlyAccount<TAccountSeat> : TAccountSeat,
    TAccountBaseAccount extends string ? WritableAccount<TAccountBaseAccount> : TAccountBaseAccount,
    TAccountQuoteAccount extends string ? WritableAccount<TAccountQuoteAccount> : TAccountQuoteAccount,
    TAccountBaseVault extends string ? WritableAccount<TAccountBaseVault> : TAccountBaseVault,
    TAccountQuoteVault extends string ? WritableAccount<TAccountQuoteVault> : TAccountQuoteVault,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    ...TRemainingAccounts
]>;
export type EvictSeatInstructionData = {
    discriminator: number;
};
export type EvictSeatInstructionDataArgs = {};
export declare function getEvictSeatInstructionDataEncoder(): Encoder<EvictSeatInstructionDataArgs>;
export declare function getEvictSeatInstructionDataDecoder(): Decoder<EvictSeatInstructionData>;
export declare function getEvictSeatInstructionDataCodec(): Codec<EvictSeatInstructionDataArgs, EvictSeatInstructionData>;
export type EvictSeatInput<TAccountPhoenixProgram extends string = string, TAccountLogAuthority extends string = string, TAccountMarket extends string = string, TAccountMarketAuthority extends string = string, TAccountTrader extends string = string, TAccountSeat extends string = string, TAccountBaseAccount extends string = string, TAccountQuoteAccount extends string = string, TAccountBaseVault extends string = string, TAccountQuoteVault extends string = string, TAccountTokenProgram extends string = string> = {
    /** Phoenix program */
    phoenixProgram: Address<TAccountPhoenixProgram>;
    /** Phoenix log authority */
    logAuthority: Address<TAccountLogAuthority>;
    /** This account holds the market state */
    market: Address<TAccountMarket>;
    /** The market_authority account must sign to evict a seat */
    marketAuthority: Address<TAccountMarketAuthority> | TransactionSigner<TAccountMarketAuthority>;
    trader: Address<TAccountTrader>;
    /** The trader's PDA seat account, seeds are [b'seat', market_address, trader_address] */
    seat: Address<TAccountSeat>;
    baseAccount: Address<TAccountBaseAccount>;
    quoteAccount: Address<TAccountQuoteAccount>;
    baseVault: Address<TAccountBaseVault>;
    quoteVault: Address<TAccountQuoteVault>;
    /** Token program */
    tokenProgram?: Address<TAccountTokenProgram>;
};
export declare function getEvictSeatInstruction<TAccountPhoenixProgram extends string, TAccountLogAuthority extends string, TAccountMarket extends string, TAccountMarketAuthority extends string, TAccountTrader extends string, TAccountSeat extends string, TAccountBaseAccount extends string, TAccountQuoteAccount extends string, TAccountBaseVault extends string, TAccountQuoteVault extends string, TAccountTokenProgram extends string>(input: EvictSeatInput<TAccountPhoenixProgram, TAccountLogAuthority, TAccountMarket, TAccountMarketAuthority, TAccountTrader, TAccountSeat, TAccountBaseAccount, TAccountQuoteAccount, TAccountBaseVault, TAccountQuoteVault, TAccountTokenProgram>): EvictSeatInstruction<typeof PHOENIX_V1_PROGRAM_ADDRESS, TAccountPhoenixProgram, TAccountLogAuthority, TAccountMarket, (typeof input)['marketAuthority'] extends TransactionSigner<TAccountMarketAuthority> ? ReadonlySignerAccount<TAccountMarketAuthority> & IAccountSignerMeta<TAccountMarketAuthority> : TAccountMarketAuthority, TAccountTrader, TAccountSeat, TAccountBaseAccount, TAccountQuoteAccount, TAccountBaseVault, TAccountQuoteVault, TAccountTokenProgram>;
export type ParsedEvictSeatInstruction<TProgram extends string = typeof PHOENIX_V1_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Phoenix program */
        phoenixProgram: TAccountMetas[0];
        /** Phoenix log authority */
        logAuthority: TAccountMetas[1];
        /** This account holds the market state */
        market: TAccountMetas[2];
        /** The market_authority account must sign to evict a seat */
        marketAuthority: TAccountMetas[3];
        trader: TAccountMetas[4];
        /** The trader's PDA seat account, seeds are [b'seat', market_address, trader_address] */
        seat: TAccountMetas[5];
        baseAccount: TAccountMetas[6];
        quoteAccount: TAccountMetas[7];
        baseVault: TAccountMetas[8];
        quoteVault: TAccountMetas[9];
        /** Token program */
        tokenProgram: TAccountMetas[10];
    };
    data: EvictSeatInstructionData;
};
export declare function parseEvictSeatInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedEvictSeatInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=evictSeat.d.ts.map