/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlySignerAccount, TransactionSigner, WritableAccount } from '@solana/web3.js';
import { PHOENIX_V1_PROGRAM_ADDRESS } from '../programs';
import { CancelUpToParams, CancelUpToParamsArgs } from '../types';
export type ForceCancelOrdersInstruction<TProgram extends string = typeof PHOENIX_V1_PROGRAM_ADDRESS, TAccountPhoenixProgram extends string | IAccountMeta<string> = string, TAccountLogAuthority extends string | IAccountMeta<string> = string, TAccountMarket extends string | IAccountMeta<string> = string, TAccountMarketAuthority extends string | IAccountMeta<string> = string, TAccountTrader extends string | IAccountMeta<string> = string, TAccountSeat extends string | IAccountMeta<string> = string, TAccountBaseAccount extends string | IAccountMeta<string> = string, TAccountQuoteAccount extends string | IAccountMeta<string> = string, TAccountBaseVault extends string | IAccountMeta<string> = string, TAccountQuoteVault extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPhoenixProgram extends string ? ReadonlyAccount<TAccountPhoenixProgram> : TAccountPhoenixProgram,
    TAccountLogAuthority extends string ? ReadonlyAccount<TAccountLogAuthority> : TAccountLogAuthority,
    TAccountMarket extends string ? WritableAccount<TAccountMarket> : TAccountMarket,
    TAccountMarketAuthority extends string ? ReadonlyAccount<TAccountMarketAuthority> : TAccountMarketAuthority,
    TAccountTrader extends string ? ReadonlyAccount<TAccountTrader> : TAccountTrader,
    TAccountSeat extends string ? ReadonlyAccount<TAccountSeat> : TAccountSeat,
    TAccountBaseAccount extends string ? WritableAccount<TAccountBaseAccount> : TAccountBaseAccount,
    TAccountQuoteAccount extends string ? WritableAccount<TAccountQuoteAccount> : TAccountQuoteAccount,
    TAccountBaseVault extends string ? WritableAccount<TAccountBaseVault> : TAccountBaseVault,
    TAccountQuoteVault extends string ? WritableAccount<TAccountQuoteVault> : TAccountQuoteVault,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    ...TRemainingAccounts
]>;
export type ForceCancelOrdersInstructionData = {
    discriminator: number;
    params: CancelUpToParams;
};
export type ForceCancelOrdersInstructionDataArgs = {
    params: CancelUpToParamsArgs;
};
export declare function getForceCancelOrdersInstructionDataEncoder(): Encoder<ForceCancelOrdersInstructionDataArgs>;
export declare function getForceCancelOrdersInstructionDataDecoder(): Decoder<ForceCancelOrdersInstructionData>;
export declare function getForceCancelOrdersInstructionDataCodec(): Codec<ForceCancelOrdersInstructionDataArgs, ForceCancelOrdersInstructionData>;
export type ForceCancelOrdersInput<TAccountPhoenixProgram extends string = string, TAccountLogAuthority extends string = string, TAccountMarket extends string = string, TAccountMarketAuthority extends string = string, TAccountTrader extends string = string, TAccountSeat extends string = string, TAccountBaseAccount extends string = string, TAccountQuoteAccount extends string = string, TAccountBaseVault extends string = string, TAccountQuoteVault extends string = string, TAccountTokenProgram extends string = string> = {
    /** Phoenix program */
    phoenixProgram: Address<TAccountPhoenixProgram>;
    /** Phoenix log authority */
    logAuthority: Address<TAccountLogAuthority>;
    /** This account holds the market state */
    market: Address<TAccountMarket>;
    /** The market_authority account must sign to claim authority */
    marketAuthority: Address<TAccountMarketAuthority> | TransactionSigner<TAccountMarketAuthority>;
    trader: Address<TAccountTrader>;
    /** The trader's PDA seat account, seeds are [b'seat', market_address, trader_address] */
    seat: Address<TAccountSeat>;
    /** Trader base token account */
    baseAccount: Address<TAccountBaseAccount>;
    /** Trader quote token account */
    quoteAccount: Address<TAccountQuoteAccount>;
    /** Base vault PDA, seeds are [b'vault', market_address, base_mint_address] */
    baseVault: Address<TAccountBaseVault>;
    /** Quote vault PDA, seeds are [b'vault', market_address, quote_mint_address] */
    quoteVault: Address<TAccountQuoteVault>;
    /** Token program */
    tokenProgram?: Address<TAccountTokenProgram>;
    params: ForceCancelOrdersInstructionDataArgs['params'];
};
export declare function getForceCancelOrdersInstruction<TAccountPhoenixProgram extends string, TAccountLogAuthority extends string, TAccountMarket extends string, TAccountMarketAuthority extends string, TAccountTrader extends string, TAccountSeat extends string, TAccountBaseAccount extends string, TAccountQuoteAccount extends string, TAccountBaseVault extends string, TAccountQuoteVault extends string, TAccountTokenProgram extends string>(input: ForceCancelOrdersInput<TAccountPhoenixProgram, TAccountLogAuthority, TAccountMarket, TAccountMarketAuthority, TAccountTrader, TAccountSeat, TAccountBaseAccount, TAccountQuoteAccount, TAccountBaseVault, TAccountQuoteVault, TAccountTokenProgram>): ForceCancelOrdersInstruction<typeof PHOENIX_V1_PROGRAM_ADDRESS, TAccountPhoenixProgram, TAccountLogAuthority, TAccountMarket, (typeof input)['marketAuthority'] extends TransactionSigner<TAccountMarketAuthority> ? ReadonlySignerAccount<TAccountMarketAuthority> & IAccountSignerMeta<TAccountMarketAuthority> : TAccountMarketAuthority, TAccountTrader, TAccountSeat, TAccountBaseAccount, TAccountQuoteAccount, TAccountBaseVault, TAccountQuoteVault, TAccountTokenProgram>;
export type ParsedForceCancelOrdersInstruction<TProgram extends string = typeof PHOENIX_V1_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Phoenix program */
        phoenixProgram: TAccountMetas[0];
        /** Phoenix log authority */
        logAuthority: TAccountMetas[1];
        /** This account holds the market state */
        market: TAccountMetas[2];
        /** The market_authority account must sign to claim authority */
        marketAuthority: TAccountMetas[3];
        trader: TAccountMetas[4];
        /** The trader's PDA seat account, seeds are [b'seat', market_address, trader_address] */
        seat: TAccountMetas[5];
        /** Trader base token account */
        baseAccount: TAccountMetas[6];
        /** Trader quote token account */
        quoteAccount: TAccountMetas[7];
        /** Base vault PDA, seeds are [b'vault', market_address, base_mint_address] */
        baseVault: TAccountMetas[8];
        /** Quote vault PDA, seeds are [b'vault', market_address, quote_mint_address] */
        quoteVault: TAccountMetas[9];
        /** Token program */
        tokenProgram: TAccountMetas[10];
    };
    data: ForceCancelOrdersInstructionData;
};
export declare function parseForceCancelOrdersInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedForceCancelOrdersInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=forceCancelOrders.d.ts.map