/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, Option, OptionOrNullable, ReadonlyAccount, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { PHOENIX_V1_PROGRAM_ADDRESS } from '../programs';
import { MarketSizeParams, MarketSizeParamsArgs } from '../types';
export type InitializeMarketInstruction<TProgram extends string = typeof PHOENIX_V1_PROGRAM_ADDRESS, TAccountPhoenixProgram extends string | IAccountMeta<string> = string, TAccountLogAuthority extends string | IAccountMeta<string> = string, TAccountMarket extends string | IAccountMeta<string> = string, TAccountMarketCreator extends string | IAccountMeta<string> = string, TAccountBaseMint extends string | IAccountMeta<string> = string, TAccountQuoteMint extends string | IAccountMeta<string> = string, TAccountBaseVault extends string | IAccountMeta<string> = string, TAccountQuoteVault extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPhoenixProgram extends string ? ReadonlyAccount<TAccountPhoenixProgram> : TAccountPhoenixProgram,
    TAccountLogAuthority extends string ? ReadonlyAccount<TAccountLogAuthority> : TAccountLogAuthority,
    TAccountMarket extends string ? WritableAccount<TAccountMarket> : TAccountMarket,
    TAccountMarketCreator extends string ? WritableAccount<TAccountMarketCreator> : TAccountMarketCreator,
    TAccountBaseMint extends string ? ReadonlyAccount<TAccountBaseMint> : TAccountBaseMint,
    TAccountQuoteMint extends string ? ReadonlyAccount<TAccountQuoteMint> : TAccountQuoteMint,
    TAccountBaseVault extends string ? WritableAccount<TAccountBaseVault> : TAccountBaseVault,
    TAccountQuoteVault extends string ? WritableAccount<TAccountQuoteVault> : TAccountQuoteVault,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    ...TRemainingAccounts
]>;
export type InitializeMarketInstructionData = {
    discriminator: number;
    marketSizeParams: MarketSizeParams;
    numQuoteLotsPerQuoteUnit: bigint;
    tickSizeInQuoteLotsPerBaseUnit: bigint;
    numBaseLotsPerBaseUnit: bigint;
    takerFeeBps: number;
    feeCollector: Address;
    rawBaseUnitsPerBaseUnit: Option<number>;
};
export type InitializeMarketInstructionDataArgs = {
    marketSizeParams: MarketSizeParamsArgs;
    numQuoteLotsPerQuoteUnit: number | bigint;
    tickSizeInQuoteLotsPerBaseUnit: number | bigint;
    numBaseLotsPerBaseUnit: number | bigint;
    takerFeeBps: number;
    feeCollector: Address;
    rawBaseUnitsPerBaseUnit: OptionOrNullable<number>;
};
export declare function getInitializeMarketInstructionDataEncoder(): Encoder<InitializeMarketInstructionDataArgs>;
export declare function getInitializeMarketInstructionDataDecoder(): Decoder<InitializeMarketInstructionData>;
export declare function getInitializeMarketInstructionDataCodec(): Codec<InitializeMarketInstructionDataArgs, InitializeMarketInstructionData>;
export type InitializeMarketInput<TAccountPhoenixProgram extends string = string, TAccountLogAuthority extends string = string, TAccountMarket extends string = string, TAccountMarketCreator extends string = string, TAccountBaseMint extends string = string, TAccountQuoteMint extends string = string, TAccountBaseVault extends string = string, TAccountQuoteVault extends string = string, TAccountSystemProgram extends string = string, TAccountTokenProgram extends string = string> = {
    /** Phoenix program */
    phoenixProgram: Address<TAccountPhoenixProgram>;
    /** Phoenix log authority */
    logAuthority: Address<TAccountLogAuthority>;
    /** This account holds the market state */
    market: Address<TAccountMarket>;
    /** The market_creator account must sign for the creation of new vaults */
    marketCreator: Address<TAccountMarketCreator> | TransactionSigner<TAccountMarketCreator>;
    /** Base mint account */
    baseMint: Address<TAccountBaseMint>;
    /** Quote mint account */
    quoteMint: Address<TAccountQuoteMint>;
    /** Base vault PDA, seeds are [b'vault', market_address, base_mint_address] */
    baseVault: Address<TAccountBaseVault>;
    /** Quote vault PDA, seeds are [b'vault', market_address, quote_mint_address] */
    quoteVault: Address<TAccountQuoteVault>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Token program */
    tokenProgram?: Address<TAccountTokenProgram>;
    marketSizeParams: InitializeMarketInstructionDataArgs['marketSizeParams'];
    numQuoteLotsPerQuoteUnit: InitializeMarketInstructionDataArgs['numQuoteLotsPerQuoteUnit'];
    tickSizeInQuoteLotsPerBaseUnit: InitializeMarketInstructionDataArgs['tickSizeInQuoteLotsPerBaseUnit'];
    numBaseLotsPerBaseUnit: InitializeMarketInstructionDataArgs['numBaseLotsPerBaseUnit'];
    takerFeeBps: InitializeMarketInstructionDataArgs['takerFeeBps'];
    feeCollector: InitializeMarketInstructionDataArgs['feeCollector'];
    rawBaseUnitsPerBaseUnit: InitializeMarketInstructionDataArgs['rawBaseUnitsPerBaseUnit'];
};
export declare function getInitializeMarketInstruction<TAccountPhoenixProgram extends string, TAccountLogAuthority extends string, TAccountMarket extends string, TAccountMarketCreator extends string, TAccountBaseMint extends string, TAccountQuoteMint extends string, TAccountBaseVault extends string, TAccountQuoteVault extends string, TAccountSystemProgram extends string, TAccountTokenProgram extends string>(input: InitializeMarketInput<TAccountPhoenixProgram, TAccountLogAuthority, TAccountMarket, TAccountMarketCreator, TAccountBaseMint, TAccountQuoteMint, TAccountBaseVault, TAccountQuoteVault, TAccountSystemProgram, TAccountTokenProgram>): InitializeMarketInstruction<typeof PHOENIX_V1_PROGRAM_ADDRESS, TAccountPhoenixProgram, TAccountLogAuthority, TAccountMarket, (typeof input)['marketCreator'] extends TransactionSigner<TAccountMarketCreator> ? WritableSignerAccount<TAccountMarketCreator> & IAccountSignerMeta<TAccountMarketCreator> : TAccountMarketCreator, TAccountBaseMint, TAccountQuoteMint, TAccountBaseVault, TAccountQuoteVault, TAccountSystemProgram, TAccountTokenProgram>;
export type ParsedInitializeMarketInstruction<TProgram extends string = typeof PHOENIX_V1_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Phoenix program */
        phoenixProgram: TAccountMetas[0];
        /** Phoenix log authority */
        logAuthority: TAccountMetas[1];
        /** This account holds the market state */
        market: TAccountMetas[2];
        /** The market_creator account must sign for the creation of new vaults */
        marketCreator: TAccountMetas[3];
        /** Base mint account */
        baseMint: TAccountMetas[4];
        /** Quote mint account */
        quoteMint: TAccountMetas[5];
        /** Base vault PDA, seeds are [b'vault', market_address, base_mint_address] */
        baseVault: TAccountMetas[6];
        /** Quote vault PDA, seeds are [b'vault', market_address, quote_mint_address] */
        quoteVault: TAccountMetas[7];
        /** System program */
        systemProgram: TAccountMetas[8];
        /** Token program */
        tokenProgram: TAccountMetas[9];
    };
    data: InitializeMarketInstructionData;
};
export declare function parseInitializeMarketInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedInitializeMarketInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=initializeMarket.d.ts.map