/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlySignerAccount, TransactionSigner, WritableAccount } from '@solana/web3.js';
import { PHOENIX_V1_PROGRAM_ADDRESS } from '../programs';
import { ReduceOrderParams, ReduceOrderParamsArgs } from '../types';
export type ReduceOrderInstruction<TProgram extends string = typeof PHOENIX_V1_PROGRAM_ADDRESS, TAccountPhoenixProgram extends string | IAccountMeta<string> = string, TAccountLogAuthority extends string | IAccountMeta<string> = string, TAccountMarket extends string | IAccountMeta<string> = string, TAccountTrader extends string | IAccountMeta<string> = string, TAccountBaseAccount extends string | IAccountMeta<string> = string, TAccountQuoteAccount extends string | IAccountMeta<string> = string, TAccountBaseVault extends string | IAccountMeta<string> = string, TAccountQuoteVault extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPhoenixProgram extends string ? ReadonlyAccount<TAccountPhoenixProgram> : TAccountPhoenixProgram,
    TAccountLogAuthority extends string ? ReadonlyAccount<TAccountLogAuthority> : TAccountLogAuthority,
    TAccountMarket extends string ? WritableAccount<TAccountMarket> : TAccountMarket,
    TAccountTrader extends string ? ReadonlyAccount<TAccountTrader> : TAccountTrader,
    TAccountBaseAccount extends string ? WritableAccount<TAccountBaseAccount> : TAccountBaseAccount,
    TAccountQuoteAccount extends string ? WritableAccount<TAccountQuoteAccount> : TAccountQuoteAccount,
    TAccountBaseVault extends string ? WritableAccount<TAccountBaseVault> : TAccountBaseVault,
    TAccountQuoteVault extends string ? WritableAccount<TAccountQuoteVault> : TAccountQuoteVault,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    ...TRemainingAccounts
]>;
export type ReduceOrderInstructionData = {
    discriminator: number;
    params: ReduceOrderParams;
};
export type ReduceOrderInstructionDataArgs = {
    params: ReduceOrderParamsArgs;
};
export declare function getReduceOrderInstructionDataEncoder(): Encoder<ReduceOrderInstructionDataArgs>;
export declare function getReduceOrderInstructionDataDecoder(): Decoder<ReduceOrderInstructionData>;
export declare function getReduceOrderInstructionDataCodec(): Codec<ReduceOrderInstructionDataArgs, ReduceOrderInstructionData>;
export type ReduceOrderInput<TAccountPhoenixProgram extends string = string, TAccountLogAuthority extends string = string, TAccountMarket extends string = string, TAccountTrader extends string = string, TAccountBaseAccount extends string = string, TAccountQuoteAccount extends string = string, TAccountBaseVault extends string = string, TAccountQuoteVault extends string = string, TAccountTokenProgram extends string = string> = {
    /** Phoenix program */
    phoenixProgram: Address<TAccountPhoenixProgram>;
    /** Phoenix log authority */
    logAuthority: Address<TAccountLogAuthority>;
    /** This account holds the market state */
    market: Address<TAccountMarket>;
    trader: Address<TAccountTrader> | TransactionSigner<TAccountTrader>;
    /** Trader base token account */
    baseAccount: Address<TAccountBaseAccount>;
    /** Trader quote token account */
    quoteAccount: Address<TAccountQuoteAccount>;
    /** Base vault PDA, seeds are [b'vault', market_address, base_mint_address] */
    baseVault: Address<TAccountBaseVault>;
    /** Quote vault PDA, seeds are [b'vault', market_address, quote_mint_address] */
    quoteVault: Address<TAccountQuoteVault>;
    /** Token program */
    tokenProgram?: Address<TAccountTokenProgram>;
    params: ReduceOrderInstructionDataArgs['params'];
};
export declare function getReduceOrderInstruction<TAccountPhoenixProgram extends string, TAccountLogAuthority extends string, TAccountMarket extends string, TAccountTrader extends string, TAccountBaseAccount extends string, TAccountQuoteAccount extends string, TAccountBaseVault extends string, TAccountQuoteVault extends string, TAccountTokenProgram extends string>(input: ReduceOrderInput<TAccountPhoenixProgram, TAccountLogAuthority, TAccountMarket, TAccountTrader, TAccountBaseAccount, TAccountQuoteAccount, TAccountBaseVault, TAccountQuoteVault, TAccountTokenProgram>): ReduceOrderInstruction<typeof PHOENIX_V1_PROGRAM_ADDRESS, TAccountPhoenixProgram, TAccountLogAuthority, TAccountMarket, (typeof input)['trader'] extends TransactionSigner<TAccountTrader> ? ReadonlySignerAccount<TAccountTrader> & IAccountSignerMeta<TAccountTrader> : TAccountTrader, TAccountBaseAccount, TAccountQuoteAccount, TAccountBaseVault, TAccountQuoteVault, TAccountTokenProgram>;
export type ParsedReduceOrderInstruction<TProgram extends string = typeof PHOENIX_V1_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Phoenix program */
        phoenixProgram: TAccountMetas[0];
        /** Phoenix log authority */
        logAuthority: TAccountMetas[1];
        /** This account holds the market state */
        market: TAccountMetas[2];
        trader: TAccountMetas[3];
        /** Trader base token account */
        baseAccount: TAccountMetas[4];
        /** Trader quote token account */
        quoteAccount: TAccountMetas[5];
        /** Base vault PDA, seeds are [b'vault', market_address, base_mint_address] */
        baseVault: TAccountMetas[6];
        /** Quote vault PDA, seeds are [b'vault', market_address, quote_mint_address] */
        quoteVault: TAccountMetas[7];
        /** Token program */
        tokenProgram: TAccountMetas[8];
    };
    data: ReduceOrderInstructionData;
};
export declare function parseReduceOrderInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedReduceOrderInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=reduceOrder.d.ts.map