/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlySignerAccount, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { PHOENIX_V1_PROGRAM_ADDRESS } from '../programs';
export type RequestSeatAuthorizedInstruction<TProgram extends string = typeof PHOENIX_V1_PROGRAM_ADDRESS, TAccountPhoenixProgram extends string | IAccountMeta<string> = string, TAccountLogAuthority extends string | IAccountMeta<string> = string, TAccountMarket extends string | IAccountMeta<string> = string, TAccountMarketAuthority extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountTrader extends string | IAccountMeta<string> = string, TAccountSeat extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPhoenixProgram extends string ? ReadonlyAccount<TAccountPhoenixProgram> : TAccountPhoenixProgram,
    TAccountLogAuthority extends string ? ReadonlyAccount<TAccountLogAuthority> : TAccountLogAuthority,
    TAccountMarket extends string ? WritableAccount<TAccountMarket> : TAccountMarket,
    TAccountMarketAuthority extends string ? ReadonlyAccount<TAccountMarketAuthority> : TAccountMarketAuthority,
    TAccountPayer extends string ? WritableAccount<TAccountPayer> : TAccountPayer,
    TAccountTrader extends string ? ReadonlyAccount<TAccountTrader> : TAccountTrader,
    TAccountSeat extends string ? WritableAccount<TAccountSeat> : TAccountSeat,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type RequestSeatAuthorizedInstructionData = {
    discriminator: number;
};
export type RequestSeatAuthorizedInstructionDataArgs = {};
export declare function getRequestSeatAuthorizedInstructionDataEncoder(): Encoder<RequestSeatAuthorizedInstructionDataArgs>;
export declare function getRequestSeatAuthorizedInstructionDataDecoder(): Decoder<RequestSeatAuthorizedInstructionData>;
export declare function getRequestSeatAuthorizedInstructionDataCodec(): Codec<RequestSeatAuthorizedInstructionDataArgs, RequestSeatAuthorizedInstructionData>;
export type RequestSeatAuthorizedInput<TAccountPhoenixProgram extends string = string, TAccountLogAuthority extends string = string, TAccountMarket extends string = string, TAccountMarketAuthority extends string = string, TAccountPayer extends string = string, TAccountTrader extends string = string, TAccountSeat extends string = string, TAccountSystemProgram extends string = string> = {
    /** Phoenix program */
    phoenixProgram: Address<TAccountPhoenixProgram>;
    /** Phoenix log authority */
    logAuthority: Address<TAccountLogAuthority>;
    /** This account holds the market state */
    market: Address<TAccountMarket>;
    /** The market_authority account must sign to request a seat on behalf of a trader */
    marketAuthority: Address<TAccountMarketAuthority> | TransactionSigner<TAccountMarketAuthority>;
    payer: Address<TAccountPayer> | TransactionSigner<TAccountPayer>;
    trader: Address<TAccountTrader>;
    seat: Address<TAccountSeat>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
};
export declare function getRequestSeatAuthorizedInstruction<TAccountPhoenixProgram extends string, TAccountLogAuthority extends string, TAccountMarket extends string, TAccountMarketAuthority extends string, TAccountPayer extends string, TAccountTrader extends string, TAccountSeat extends string, TAccountSystemProgram extends string>(input: RequestSeatAuthorizedInput<TAccountPhoenixProgram, TAccountLogAuthority, TAccountMarket, TAccountMarketAuthority, TAccountPayer, TAccountTrader, TAccountSeat, TAccountSystemProgram>): RequestSeatAuthorizedInstruction<typeof PHOENIX_V1_PROGRAM_ADDRESS, TAccountPhoenixProgram, TAccountLogAuthority, TAccountMarket, (typeof input)['marketAuthority'] extends TransactionSigner<TAccountMarketAuthority> ? ReadonlySignerAccount<TAccountMarketAuthority> & IAccountSignerMeta<TAccountMarketAuthority> : TAccountMarketAuthority, (typeof input)['payer'] extends TransactionSigner<TAccountPayer> ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer, TAccountTrader, TAccountSeat, TAccountSystemProgram>;
export type ParsedRequestSeatAuthorizedInstruction<TProgram extends string = typeof PHOENIX_V1_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Phoenix program */
        phoenixProgram: TAccountMetas[0];
        /** Phoenix log authority */
        logAuthority: TAccountMetas[1];
        /** This account holds the market state */
        market: TAccountMetas[2];
        /** The market_authority account must sign to request a seat on behalf of a trader */
        marketAuthority: TAccountMetas[3];
        payer: TAccountMetas[4];
        trader: TAccountMetas[5];
        seat: TAccountMetas[6];
        /** System program */
        systemProgram: TAccountMetas[7];
    };
    data: RequestSeatAuthorizedInstructionData;
};
export declare function parseRequestSeatAuthorizedInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedRequestSeatAuthorizedInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=requestSeatAuthorized.d.ts.map