import { Address } from '@solana/web3.js';
import { MarketHeader, MarketSizeParams } from '../generated';
export declare const MIN_MARKET_SIZE_PARAMS: MarketSizeParams;
export declare const MIN_MARKET_SIZE = 84368n;
export declare const MARKET_HEADER_SIZE = 576n;
export type OrderId = {
    priceInTicks: bigint;
    orderSeqNum: bigint;
};
export type RestingOrder = {
    traderIndex: bigint;
    numBaseLots: bigint;
    lastValidSlot: bigint;
    lastValidUnixTimestampInSeconds: bigint;
};
export type TraderState = {
    quoteLotsLocked: bigint;
    quoteLotsFree: bigint;
    baseLotsLocked: bigint;
    baseLotsFree: bigint;
    padding: bigint[];
};
export interface MarketData {
    header: MarketHeader;
    baseLotsPerBaseUnit: number;
    quoteLotsPerBaseUnitPerTick: number;
    orderSequenceNumber: number;
    takerFeeBps: number;
    collectedQuoteLotFees: number;
    unclaimedQuoteLotFees: number;
    bids: Array<[OrderId, RestingOrder]>;
    asks: Array<[OrderId, RestingOrder]>;
    traders: Map<string, TraderState>;
    traderPubkeyToTraderIndex: Map<string, number>;
    traderIndexToTraderPubkey: Map<number, string>;
}
export declare class MarketState {
    address: Address;
    data: MarketData;
    constructor(address: Address, data: MarketData);
}
//# sourceMappingURL=market.d.ts.map